import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.Graphics;
import java.awt.event.*;
import java.applet.*;
import java.util.Hashtable;
import java.awt.image.*;
import java.util.regex.Pattern;
import java.util.regex.Matcher;
import java.util.*;
import java.net.*;
import javax.imageio.*;
import java.io.*;

import java.awt.datatransfer.*;
import java.awt.dnd.*;

public class P2VConfigurePanel extends JPanel implements ActionListener{
	// P2VJ version 0.4 Copyright (C) 2010 sesamecake
	// This software is published under GPLv3.
	// For more detail, please see "readme.txt" and "GPLv3.txt" compressed with this file.
	// If you have some questions, please visit my blog http://sesamecake.blog84.fc2.com/
	// or call me via twitter http://twitter.com/sesamecake
	// THX!
	
	
	public static final int EVENT_SELECTFILE = 0;
	public static final int EVENT_CLOSE = 1;
	public static final int EVENT_CANCEL = 2;
	public static final int EVENT_RUN = 3;
	public static final int EVENT_SHOWABOUT = 4;
	
	
	
	public static final int JPANEL_CHECKBOX_BASIC = 0;
	public static final int JPANEL_CHECKBOX_ADVANCE = 1;
	public static final int JPANEL_PNGSIZE = 2;
	public static final int JPANEL_INFORMATION = 3;
	public static final int JPANEL_BUTTON_MAIN = 4;
	public static final String[] JPANEL__NAME = {"basic","advance","pngsize","information","button"};
	public static final int[] JPANEL__GROUP = {-1,-2,-1,-1,-1};
	
	public static final int JBUTTON_SELECTFILE = 0;
	public static final int JBUTTON_CANCEL = 1;
	public static final int JBUTTON_CLOSE = 2;
	public static final int JBUTTON_RUN = 3;
	public static final int JBUTTON_ABOUT = 4;
	public static final String[] JBUTTON__NAME = {"selectfile","cancel","close","run","@"};
	public static final int[] JBUTTON__GROUP = {JPANEL_BUTTON_MAIN,JPANEL_BUTTON_MAIN,JPANEL_BUTTON_MAIN,-2,JPANEL_BUTTON_MAIN};
	public static final int[] JBUTTON__EVENT ={EVENT_SELECTFILE,EVENT_CANCEL,EVENT_CLOSE,EVENT_RUN,EVENT_SHOWABOUT};
	
	
	public static final int JCHECKBOX_POSTERIZE = 0;
	public static final int JCHECKBOX_REMOVEANTIALIASE = 1;
	public static final int JCHECKBOX_MAKEPNG = 2;
	public static final int JCHECKBOX_DRAGANDRUN = 3;
	public static final String[] JCHECKBOX__NAME = {"posterize","remove anti-Aliase","makepng","drag&run"};
	public static final int[] JCHECKBOX__GROUP = {JPANEL_CHECKBOX_BASIC,JPANEL_CHECKBOX_BASIC,JPANEL_PNGSIZE,-2};
	public static final int[] JCHECKBOX__EVENT ={-1,-1,-1,-1};
	
	public static final int JLABEL_FILENAME = 0;
	public static final int JLABEL_PROGRESS = 1;
	public static final String[] JLABEL__NAME = {"file:","progress:"};
	public static final int[] JLABEL__GROUP = {JPANEL_INFORMATION,JPANEL_INFORMATION};
	
	
	Hashtable<Object,Integer> eventObjectHash = new Hashtable<Object,Integer>();
	JPanel basePanel = new JPanel();
	
	JPanel[] jPanel;
	JButton[] jButton;
	JCheckBox[] jCheckBox;
	JLabel[] jLabel;
	NumberField pngSizeField = new NumberField(NumberField.MODE_INT);
	Vector<File> processingList = new Vector<File>();
	String directory = "./";
	Thread vThread;
	boolean cancelPressed = false;
	public void setAllPanels(){
		jPanel = new JPanel[JPANEL__NAME.length];
		for(int ii = 0;ii < JPANEL__NAME.length;ii++){
			jPanel[ii] = new JPanel();
			if(JPANEL__GROUP[ii] > -1){
				jPanel[JPANEL__GROUP[ii]].add(jPanel[ii]);
			}else if(JPANEL__GROUP[ii] == -1){
				basePanel.add(jPanel[ii]);
			}
		}
		jButton = new JButton[JBUTTON__NAME.length];
		for(int ii = 0;ii < JBUTTON__NAME.length;ii++){
			jButton[ii] = new JButton(JBUTTON__NAME[ii]);
			if(JBUTTON__GROUP[ii] > -1){
				jPanel[JBUTTON__GROUP[ii]].add(jButton[ii]);
			}else if(JBUTTON__GROUP[ii] == -1){
				basePanel.add(jButton[ii]);
			}
			jButton[ii].addActionListener(this);
			if(JBUTTON__EVENT[ii] > -1){
				eventObjectHash.put(jButton[ii],JBUTTON__EVENT[ii]);
			}
			jButton[ii].setMargin(new Insets(2,2,2,2));
		}
		
		//jButton[JBUTTON_ABOUT].setMargin(new Insets(0,0,0,0));
		
		
		jLabel = new JLabel[JLABEL__NAME.length];
		for(int ii = 0;ii < JLABEL__NAME.length;ii++){
			jLabel[ii] = new JLabel(JLABEL__NAME[ii]);
			if(JLABEL__GROUP[ii] > -1){
				jPanel[JLABEL__GROUP[ii]].add(jLabel[ii]);
			}else if(JLABEL__GROUP[ii] == -1){
				basePanel.add(jLabel[ii]);
			}
		}
		jCheckBox = new JCheckBox[JCHECKBOX__NAME.length];
		for(int ii = 0;ii < JCHECKBOX__NAME.length;ii++){
			jCheckBox[ii] = new JCheckBox(JCHECKBOX__NAME[ii]);
			if(JCHECKBOX__GROUP[ii] > -1){
				jPanel[JCHECKBOX__GROUP[ii]].add(jCheckBox[ii]);
			}else if(JCHECKBOX__GROUP[ii] == -1){
				basePanel.add(jCheckBox[ii]);
			}
			jCheckBox[ii].addActionListener(this);
			if(JCHECKBOX__EVENT[ii] > -1){
				eventObjectHash.put(jCheckBox[ii],JCHECKBOX__EVENT[ii]);
			}
		}
		
		jCheckBox[JCHECKBOX_POSTERIZE].setSelected(false);
		jCheckBox[JCHECKBOX_MAKEPNG].setSelected(false);
		jCheckBox[JCHECKBOX_REMOVEANTIALIASE].setSelected(true);
		jCheckBox[JCHECKBOX_DRAGANDRUN].setSelected(true);
		
	}
	P2VConfigurePanel(){
		BoxLayout bp = new BoxLayout(basePanel,BoxLayout.Y_AXIS );
		basePanel.setLayout(bp);
		
		setAllPanels();
		pngSizeField.setValue(100);
		jPanel[JPANEL_CHECKBOX_BASIC].setLayout(new GridLayout(3,1));
		jPanel[JPANEL_CHECKBOX_BASIC].add(jPanel[JPANEL_PNGSIZE]);
		jPanel[JPANEL_PNGSIZE].add(pngSizeField);
		jPanel[JPANEL_PNGSIZE].add(new Label("%"));
		FlowLayout tf = new FlowLayout(FlowLayout.LEFT);
		tf.setHgap(0);
		jPanel[JPANEL_PNGSIZE].setLayout(tf);  
		jPanel[JPANEL_INFORMATION].setLayout(new GridLayout(2,1));
		this.add(basePanel);
		new DropTarget(this, new DropTargetAdapter(){
			public void drop( DropTargetDropEvent e ) {
				try {
					Transferable transfer = e.getTransferable();
					if (transfer.isDataFlavorSupported( DataFlavor.javaFileListFlavor ) ) {
						e.acceptDrop(DnDConstants.ACTION_COPY_OR_MOVE);
						java.util.List fileList =(java.util.List)( transfer.getTransferData( DataFlavor.javaFileListFlavor ) );
						for(int ii = 0;ii < fileList.size();ii++){
							//Image img = loadImageFile(((File)fileList.get(ii)).getPath());
							//System.out.println(((File)fileList.get(ii)).getPath());
							processingList.add((File)fileList.get(ii));
						}
						jButton[JBUTTON_RUN].doClick();
					}
				} catch (Exception ex) {
					ex.printStackTrace();
				}
			}
		});
	}
	public PolycoCanvas vectorize(String infile){
		BufferedImage img = null;
		PolycoCanvas ret = null;
		try{
			img = ImageIO.read(new File(infile));
		}catch(Exception exx){
			exx.printStackTrace();
			img = null;
		}
		if(img == null){
			System.out.println("ImageIO ERROR");
		}else if (img.getWidth() < 20 || img.getHeight() < 20){
			System.out.println("Too small image!");
		
		}else{
			int posterize = -1;
			if(jCheckBox[JCHECKBOX_POSTERIZE].isSelected()){
				posterize = 16;
			}
			ret = BitMapVectorizer.getAllPath(img,6,3,posterize,jCheckBox[JCHECKBOX_REMOVEANTIALIASE].isSelected(),false,jLabel[JLABEL_PROGRESS]);
		}
		return ret;
	}
	public String getOutFileName(String infile,String ext){
		String base = infile.replaceAll("\\.[^.]+$","");
		String ret = base+ext;
		int num = 0;
		File f = new File(ret);
		while(f.exists()){
			ret = base+"_"+String.valueOf(num++)+ext;
			f = new File(ret);
		}
		return ret;
	}
	public void actionPerformed(ActionEvent e){
		if(eventObjectHash.get(e.getSource()) != null){
			switch(eventObjectHash.get(e.getSource())){
				case EVENT_CLOSE:
				Container c = getParent();
				while(c.getParent() != null){
					c = c.getParent();
				}
				if(c.getClass() == JFrame.class){
					((JFrame)c).dispose();
				}
				break;
				
				case EVENT_CANCEL:
				cancelPressed = true;
				processingList.clear();
				BitMapVectorizer.cancelPressed = true;
				break;
				case EVENT_SELECTFILE:
				 {
					JFileChooser fc = new JFileChooser(directory);
					fc.setFileSelectionMode(JFileChooser.FILES_ONLY);
					fc.setMultiSelectionEnabled(true);
					int selected = fc.showOpenDialog(this);
					if(selected == JFileChooser.APPROVE_OPTION){
						File[] fl = fc.getSelectedFiles() ;
						for(int ii = 0;ii < fl.length;ii++){
							processingList.add(fl[ii]);
						}
					}
					jButton[JBUTTON_RUN].doClick();
				}
				break;
				case EVENT_SHOWABOUT:
					showMessage("\"P2VJ\" Generates SVG from Raster images.\n"
								+"Copyright (C) 2010 sesamecake\n"
								+"http://sesamecake.blog84.fc2.com/\n\n"
								
								+"This program is free software: you can redistribute it and/or modify\n"
								+"it under the terms of the GNU General Public License as published by\n"
								+"the Free Software Foundation, either version 3 of the License, or\n"
								+" any later version.\n"
								+"\n"
								+"This program is distributed in the hope that it will be useful,\n"
								+"but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
								+"MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n"
								+"GNU General Public License for more details.\n"
								
								+"\n"
								+"You should have received a copy of the GNU General Public License\n"
								+"along with this program.   If not, see <http://www.gnu.org/licenses/>.\n"
					);
				break;
				case EVENT_RUN:
					if(vThread != null && vThread.isAlive())break;
					vThread = new Thread() {
				        public void start() {
				           super.start();
							cancelPressed = false;
				        }
						public void run(){
							
							while(processingList.size() > 0){
								File file = processingList.remove(0);
								jLabel[JLABEL_FILENAME].setText("file: "+file.getName());
								repaint();
								if(file.getParent() != null){
									directory = file.getParent();
								}
								PolycoCanvas pc = vectorize(file.getPath());
								if(cancelPressed){
									jLabel[JLABEL_FILENAME].setText("canceled");
									
									break;
								}
								if(pc != null){
									String outfile = getOutFileName(file.getPath(),".svg");
									SVGParser.saveToFile(outfile,pc);
									
									if(jCheckBox[JCHECKBOX_MAKEPNG].isSelected()){
										try{
											double zoom = pngSizeField.getValue()/100;
											if(zoom == 0.0){
												pngSizeField.setValue(100);
												zoom = 1;
											}
											
											int wid = (int)(pc.getWidth()*zoom);
											int hei = (int)(pc.getHeight()*zoom);
											BufferedImage vbi = new BufferedImage(wid,hei,BufferedImage.TYPE_INT_ARGB);
											Graphics2D g2 = vbi.createGraphics();
											g2.setColor(Color.white);
											g2.fillRect(0,0,wid,hei);
											g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
											g2.setRenderingHint(RenderingHints.KEY_COLOR_RENDERING,RenderingHints.VALUE_COLOR_RENDER_QUALITY);
											g2.setRenderingHint(RenderingHints.KEY_RENDERING,RenderingHints.VALUE_RENDER_QUALITY);
											FlexPoint.setModiValues(zoom,0,0);
											pc.adjustZoom();
											pc.paint(g2);
											String pngoutfile = getOutFileName(file.getPath()+"_vec",".png");
											ImageIOWrapper.saveToFile(vbi,pngoutfile);
											
										}catch(Exception exx){
											exx.printStackTrace();
										}
									}
									
									
								}else{
									System.out.println("Could not vectorize "+file.getPath()+".");
								}
								
							}
							jLabel[JLABEL_FILENAME].setText("file: completed");
							repaint();
						}
					};
				vThread.start();
				break;
				
			}
		}
	}

	public void showMessage(String mess){
		JTextArea messArea = new JTextArea(mess,5,25);
		messArea.setOpaque(false);
		messArea.setAlignmentX(TextArea.CENTER_ALIGNMENT);
		messArea.setEditable(false);
		
		JOptionPane.showMessageDialog(this,messArea, 
				"Message", JOptionPane.INFORMATION_MESSAGE);
	}
	public static void main(String[] args){
		P2VConfigurePanel p2v = new P2VConfigurePanel();
		JFrame jf = new JFrame("P2VJ");
		jf.add(p2v);
		jf.pack();
		jf.setLocationRelativeTo(null);
		jf.setVisible(true);
		jf.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		
	}
}